Bug 433018 - rc.d/init.d/functions:status() should consider pid files before pidof
rc.d/init.d/functions:status() should consider pid files before pidof
Product: Fedora
Classification: Fedora
Component: initscripts (Show other bugs)
All Linux
low Severity low
: ---
: ---
Assigned To: Bill Nottingham
Fedora Extras Quality Assurance
Depends On:
Blocks: 440658
  Show dependency treegraph
Reported: 2008-02-15 13:14 EST by Matthew Farrellee
Modified: 2014-03-16 23:12 EDT (History)
1 user (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Last Closed: 2008-09-24 10:14:46 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---

Attachments (Terms of Use)
proposed patch to rc.d/init.d/functions (1.26 KB, text/x-patch)
2008-02-15 13:14 EST, Matthew Farrellee
no flags Details

  None (edit)
Description Matthew Farrellee 2008-02-15 13:14:35 EST
Description of problem:

The status() function from rc.d/init.d/functions uses pidof to locate pids
before considering pid files. A service that uses pid files will not have them
considered, except for the pid dead but pid file exists case, and pids of
processes with the same name as the service may be incorrectly associated with
the service.

This can result in issues during "service X start" when the init script for X is
written to be LSB-ish compliant (only start if not running) and it uses status()
to determine if the service is running.

Version-Release number of selected component (if applicable):

At least version initscripts 8.60-1 and 8.63-1

Additional info:

A proposed solution is attached as a patch to initscripts-8.63. It changes the
logic of status() to consider pid files only if one is available. There is no
logical change for init scripts that do not use pid files, they will still use
pidof to locate pids of their processes. The logical change for scripts that use
pid files is that they cannot have similarly named processes inadvertently
associated with their service, a good thing. However, if the script uses pid
files and those pid files are improperly managed, i.e. don't hold correct pids
for the service or are not removed when the service stops, the script is
essentially relying on pidof and this change will expose the dependency and the
broken pid file management.
Comment 1 Matthew Farrellee 2008-02-15 13:14:35 EST
Created attachment 295025 [details]
proposed patch to rc.d/init.d/functions
Comment 2 Bill Nottingham 2008-09-24 10:14:46 EDT
I'm leery of removing the fallback to pidof; this would cause status to behave differently from killproc, etc. 

Fixed in:

Note You need to log in before you can comment on or make changes to this bug.